var headerMsgLock = false;
function write_msg (message){
	if (headerMsgLock){
		setTimeout('write_msg("'+message+'");', 300);
		return;
	}
	headerMsgLock = true;
	headerDiv = document.getElementById("divAppboxHeader");
	var labelBefore = headerDiv.innerHTML;
	headerDiv.innerHTML = '<table width=100% cellspacing="0" cellpadding="0" border="0"><tbody><tr><th width="40%"></th><th noWrap class="action_info_th">'+message+'</th><th width="40%"></th></tr></tbody></table>';
	setTimeout('headerMsgLock = false; document.getElementById("divAppboxHeader").innerHTML = \"'+labelBefore+'\";', 2000);
}

// This array stores the events in table to avoid conflict in screen
var screenTable = new Array();
var today = new Date();
var weekDay = today.getDay();
function createEventDiv(eventDiv){
	eventDiv.className = "event_div";
	eventDiv.style.height = parseInt(eventDiv.childNodes[1].id-eventDiv.childNodes[0].id)/120000+"px";
	var end_ = timeStamp2id(eventDiv.childNodes[1].id).substr(8);
	var start_ = parseInt(timeStamp2id(eventDiv.childNodes[0].id).substr(8),10);
	if (viewType == "Day"){
		if (!screenTable[weekDay])
			screenTable[weekDay] = new Array();
		eventDiv.style.width = "190px";

		currentPos = 1;
		for (var hour = parseInt(start_,10); hour < parseInt(end_,10);(hour%100 == 30)?hour+=70:hour+=30){
			if (!screenTable[weekDay][hour])
				screenTable[weekDay][hour] = 0;

			if (currentPos <= screenTable[weekDay][hour])
				currentPos = screenTable[weekDay][hour]+1;
		}
		for (var hour = parseInt(start_,10); hour < parseInt(end_,10);(hour%100 == 30)?hour+=70:hour+=30)
			screenTable[weekDay][hour] = currentPos;
		eventDiv.style.left  = 90+(205*(currentPos-1)) + "px" ;
		eventDiv.onmouseover = function(){ createButtons(eventDiv); };
		eventDiv.onmouseout = function(){ removeButtons(eventDiv); };
		var resizeDiv = document.createElement('DIV');
		resizeDiv.id = "resize_" + eventDiv.id;
		resizeDiv.className = 'resize_div';
		resizeDiv.onmousedown = function() { resizeEvent(eventDiv); };
		eventDiv.appendChild(resizeDiv);
	}
	if (viewType == "Week"){
		var tempDate = new Date;
		tempDate.setTime(eventDiv.childNodes[1].id);
		if (!screenTable[tempDate.getDay()])
			screenTable[tempDate.getDay()] = new Array();
		currentPos = 1;
		if (!screenTable[tempDate.getDay()][start_])
			screenTable[tempDate.getDay()][start_] = 0;

		if (currentPos <= screenTable[tempDate.getDay()][start_])
			currentPos = screenTable[tempDate.getDay()][start_]+1;
		screenTable[tempDate.getDay()][start_] = currentPos;

		var widthValue = 100;
		eventDiv.style.width = widthValue+"px";

		var headerElement = document.getElementById('weekHeader_'+timeStamp2id(eventDiv.childNodes[1].id).substr(0,8));
		if (currentPos > 1)
			eventDiv.style.left = (10+(tempDate.getDay()*122)+(widthValue*currentPos))+"px";
		headerElement.style.width = (widthValue*currentPos)+"px";
		eventDiv.style.height = "20px";
		eventDiv.style.cursor = "pointer";
		eventDiv.onmouseover = function () { this.style.height = "auto"; this.style.zIndex = 2;};
		eventDiv.onmouseout = function () { this.style.height = "20px"; this.style.zIndex = 1; };
		eventDiv.onclick = function () { calendar.getView('div_main','Day','&time='+timeStamp2id(eventDiv.childNodes[1].id).substr(0,8)); };
	}

	var tdElement = document.getElementById(timeStamp2id(eventDiv.childNodes[0].id));

	if (viewType == "Month"){
		var tdElement = document.getElementById(timeStamp2id(eventDiv.childNodes[0].id).substr(0,8)+'0000');
		eventDiv.style.width = "60px";
		eventDiv.style.height = "15px";
		eventDiv.onmouseover = function () { if (this.childNodes[2].length > 9) this.style.width = "auto"; this.style.zIndex = 2; };
		eventDiv.onmouseout = function () { this.style.width = "60px"; this.style.zIndex = 1; };
		eventDiv.onclick = function () { calendar.getView('div_main','Day','&time='+timeStamp2id(eventDiv.childNodes[1].id).substr(0,8)); };
		eventDiv.style.cursor = "pointer";

		tdElement.style.height = (tdElement.childNodes.length * 10) + "px";

		if (tdElement.childNodes.length > 3)
			eventDiv.style.margin = "20 0 0 "+(20+(tdElement.childNodes.length-4)*25);
		else
			eventDiv.style.margin = "0 0 0 "+(20+(tdElement.childNodes.length-1)*25);
	}

	eventDiv.style.top  =  (tdElement.offsetTop + 145) + "px";
	tdElement.appendChild(eventDiv);
}

function createButtons(eventDiv) {
	var lnk = document.getElementById('remove_'+eventDiv.id);
	var lnk2 = document.getElementById('details_'+eventDiv.id);
	if (!lnk){
		var removeLink = document.createElement('a');
		removeLink.id = "remove_" + eventDiv.id;
		removeLink.href = "javascript:removeEvent("+eventDiv.id.substr(6)+");";
		removeLink.innerHTML = '<img onmouseover="this.setAttribute(\'width\', \'15\');"'+
			'onmouseout="this.setAttribute(\'width\', \'10\');"'+
			' title="'+get_lang('remove')+'" alt="'+get_lang('remove')+'"'+
			' src="templates/default/images/min.png"></img>';
		removeLink.style.position = "absolute";
		removeLink.style.top = "0px";
		removeLink.style.left = "175px";
		var showDetailLink = document.createElement('a');
		showDetailLink.id = "details_" + eventDiv.id;
		showDetailLink.href = "javascript:showDetails("+eventDiv.id+");";
		showDetailLink.innerHTML = '<img onmouseover="this.setAttribute(\'width\', \'15\');"'+
			'onmouseout="this.setAttribute(\'width\', \'10\');"'+
			' title="'+get_lang('details')+'" alt="'+get_lang('details')+'"'+
			' src="templates/default/images/plus.png"></img>';
		showDetailLink.style.position = "absolute";
		showDetailLink.style.top = "0px";
		showDetailLink.style.left = "160px";

		eventDiv.appendChild(showDetailLink);
		eventDiv.appendChild(removeLink);
	}
	else{
		lnk.style.visibility="visible";
		lnk2.style.visibility="visible";
	}
}

function addDetails(title,description,datetime,edatetime){
	if (!edatetime)
		edatetime = "";
	if (!datetime || datetime.length == 0)
		datetime = edatetime;
	data="<retorno>"+
	"<title>"+title+"</title>"+
	"<description>"+description+"</description>"+
	"<datetime>"+datetime.substr(4,2)+"/"+datetime.substr(6,2)+"/"+datetime.substr(0,4)+"</datetime>"+
	"<datehour>"+datetime.substr(8,2)+"</datehour>"+
	"<dateminute>"+datetime.substr(10,2)+"</dateminute>"+
	"<edatetime>"+edatetime.substr(4,2)+"/"+edatetime.substr(6,2)+"/"+edatetime.substr(0,4)+"</edatetime>"+
	"<edatehour>"+edatetime.substr(8,2)+"</edatehour>"+
	"<edateminute>"+edatetime.substr(10,2)+"</edateminute>"+
	"</retorno>";

	var divAddDialog = document.getElementById("divAddDialog");
	var xsl = XMLTools.load('xsl/detailsDialog.xsl?'+ Date.parse(new Date));
	if(!divAddDialog) {
		divAddDialog = document.createElement("DIV");
		divAddDialog.id = 'divAddDialog';
		divAddDialog.style.zIndex = "10";
		divAddDialog.style.position = "absolute";
		divAddDialog.style.display = "none";
		document.body.appendChild(divAddDialog);
	}
	divAddDialog.style.left = "300px";
	divAddDialog.style.top  = "200px";
	divAddDialog.innerHTML = xtools.parse(data, xsl);
	divAddDialog.style.display = "block";
}

function showDetails(eventId){
	var handler_getDetails = function (data)
	{
		var divAddDialog = document.getElementById("divAddDialog");
		var xsl = XMLTools.load('xsl/detailsDialog.xsl?'+ Date.parse(new Date));
		if(!divAddDialog) {
			divAddDialog = document.createElement("DIV");
			divAddDialog.id = 'divAddDialog';
			divAddDialog.style.zIndex = "10";
			divAddDialog.style.position = "absolute";
			divAddDialog.style.display = "none";
			document.body.appendChild(divAddDialog);
		}
		divAddDialog.style.left = "300px";
		divAddDialog.style.top  = "200px";
		divAddDialog.innerHTML = xtools.parse(data, xsl);
		divAddDialog.style.display = "block";
		var saveBut = document.getElementById("saveLink");
		saveBut.onclick = function () { saveEvent(eventId); }
		var startDate = document.getElementById('startstr');
		var endDate = document.getElementById('endstr');
		var startHour = document.getElementById('starthour');
		var startMin = document.getElementById('startmin');
		var endHour = document.getElementById('endhour');
		var endMin = document.getElementById('endmin');
		objDate = new Date();
		objDate.setTime(startDate.value*1000);
		startDate.value = objDate.getDate()+"/"+(objDate.getMonth()+1)+"/"+objDate.getFullYear();
		startHour.value = objDate.getHours();
		startMin.value = objDate.getMinutes();
		if (startMin.value.length < 2)
			startMin.value += "0";
		objDate.setTime(endDate.value*1000);
		endDate.value = objDate.getDate()+"/"+(objDate.getMonth()+1)+"/"+objDate.getFullYear();
		endHour.value = objDate.getHours();
		endMin.value = objDate.getMinutes();
		if (endMin.value.length < 2)
			endMin.value += "0";
		}
	XMLTools.__RETURN_MODE__ = 'XML';
	XMLTools.request('$this.uicalendar.getDetails&id='+eventId.id.substr(6), 'GET', handler_getDetails);
}
function removeButtons(eventDiv){
	var lnk = document.getElementById('remove_'+eventDiv.id);
	var lnk2 = document.getElementById('details_'+eventDiv.id);
	if (lnk){
		lnk.style.visibility="hidden";
		lnk2.style.visibility="hidden";
	}
}

function removeEvent (id) {
	var handler_removeEvent = function (data) {
		var xsl = XMLTools.load('xsl/returnData.xsl?'+ Date.parse(new Date));
                var serverRet = xtools.parse(data, xsl);
		serverRet = serverRet.substr(serverRet.indexOf('>')+1);
		var retStatus = serverRet.substr(0,5);
		if (retStatus == "false")
			write_msg(get_lang("Error") + ": " + serverRet)
		else{
			var eventDiv = document.getElementById("event_"+id);
			if (viewType == "Day"){
				init_ = timeStamp2id(eventDiv.childNodes[1].id).substr(8);
				end_ = timeStamp2id(eventDiv.childNodes[2].id).substr(8);
				for (var hour = parseInt(init_,10); hour < parseInt(end_,10);(hour%100 == 30)?hour+=70:hour+=30)
					screenTable[weekDay][hour]--;
			}
			eventDiv.parentNode.removeChild(eventDiv);
			write_msg(get_lang("Event were deleted"));
		}
	}
	XMLTools.request('$this.uicalendar.removeEvent&id='+id, 'GET', handler_removeEvent);
}

function saveEvent (id, title, description, locat, startTime, endTime){
	if (id != null){
		return changeEvent(id,'all_fields',locat);
	}

	var endDate = new Date();
	endDate.setTime(id2timeStamp(endTime)+1800000);

	var handler_Add = function (data) {
		var xsl = XMLTools.load('xsl/returnData.xsl?'+ Date.parse(new Date));
		var serverRet = xtools.parse(data, xsl);
		serverRet = serverRet.substr(serverRet.indexOf('>')+1);
		calendar.dialog('infowindow');
		var retStatus = serverRet.substr(0,5);
		if (retStatus == "false")
			write_msg(get_lang("Error") + ": " +get_lang(serverRet.substr(6)));
		else{
			var tdElement = document.getElementById(startTime);
			var eventDiv = document.createElement('DIV');
			eventDiv.id = "event_" + serverRet.substr(6,serverRet.length);
			var endDateDiv = document.createElement('DIV');
			var startDateDiv = document.createElement('DIV');
			endDateDiv.id = endDate.getTime();
			startDateDiv.id = id2timeStamp(startTime);
			eventDiv.appendChild(startDateDiv);
			eventDiv.appendChild(endDateDiv);
			eventDiv.innerHTML += title+"<br>"+description;

			createEventDiv(eventDiv);
			write_msg(get_lang("Event were added successfully!"));
		}
	}
	XMLTools.request('$this.uicalendar.saveEvent&start='+parseInt(id2timeStamp(startTime)/1000)+'&end='+parseInt(endDate.getTime()/1000)+'&title='+title+'&desc='+description+'&location='+locat, 'GET', handler_Add);
}

function quickAddEvent (title, description, startTime, endTime)
{
	var endDate = new Date();
	endDate.setTime(id2timeStamp(endTime)+1800000);

	var handler_quickAdd = function (data) {
		var xsl = XMLTools.load('xsl/returnData.xsl?'+ Date.parse(new Date));
		var serverRet = xtools.parse(data, xsl);
		serverRet = serverRet.substr(serverRet.indexOf('>')+1);
		calendar.dialog('infowindow');
		var retStatus = serverRet.substr(0,5);
		if (retStatus == "false")
			write_msg(get_lang("Error") + ": " +get_lang(serverRet.substr(6)));
		else{
			var tdElement = document.getElementById(startTime);
			var eventDiv = document.createElement('DIV');
			eventDiv.id = "event_" + serverRet.substr(6,serverRet.length);
			var endDateDiv = document.createElement('DIV');
			var startDateDiv = document.createElement('DIV');
			endDateDiv.id = endDate.getTime();
			startDateDiv.id = id2timeStamp(startTime);
			eventDiv.appendChild(startDateDiv);
			eventDiv.appendChild(endDateDiv);
			eventDiv.innerHTML += title+"<br>"+description;

			createEventDiv(eventDiv);
			write_msg(get_lang("Event were added successfully!"));
		}

	}
	XMLTools.request('$this.uicalendar.quickAdd&start='+parseInt(id2timeStamp(startTime)/1000)+'&end='+parseInt(endDate.getTime()/1000)+'&title='+title+'&desc='+description, 'GET', handler_quickAdd);
}

function changeEvent(objEvent,field,value){
	init_ = timeStamp2id(objEvent.childNodes[0].id).substr(8);
	end_ = timeStamp2id(objEvent.childNodes[1].id).substr(8);

	var handler_changeEvent = function (data){
                var xsl = XMLTools.load('xsl/returnData.xsl?'+ Date.parse(new Date));
                var serverRet = xtools.parse(data, xsl);
                serverRet = serverRet.substr(serverRet.indexOf('>')+1);
                var retStatus = serverRet.substr(1,5);
		if (retStatus == "false")
			write_msg(get_lang("Error") + ": " + serverRet)
		else
			switch (field) {
				case 'edatetime':
					for (var hour = parseInt(init_,10); hour < parseInt(end_,10);(hour%100 == 30)?hour+=70:hour+=30)
						screenTable[weekDay][hour]--;

					objEvent.childNodes[1].id = value*1000;
					var resizeIcon = document.getElementById("resize_"+objEvent.id);
					resizeIcon.parentNode.removeChild(resizeIcon);

					createEventDiv(objEvent);
					break;
				case 'all_fields':
				default:
					alert(field+': not implemented');
			}
	}
	XMLTools.request('$this.uicalendar.changeEvent&cal_id='+objEvent.id.substr(6)+'&field='+field+'&value='+value, 'GET', handler_changeEvent);
}

// Convert Unix Time Stamp to Div Id used in calendar
function timeStamp2id(timeStamp){
	var tmpDate = new Date();
	tmpDate.setTime(timeStamp);
	return (tmpDate.getYear()+(is_ie?0:1900))+""+
		(tmpDate.getDate()<10?"0"+tmpDate.getDate():tmpDate.getDate())+
		(tmpDate.getMonth()<9?"0"+(tmpDate.getMonth()+1):(tmpDate.getMonth()+1))+
		(tmpDate.getHours()<10?"0"+tmpDate.getHours():tmpDate.getHours())+
		(tmpDate.getMinutes()<10?"0"+tmpDate.getMinutes():tmpDate.getMinutes());
}

// Convert the opposite of function above
function id2timeStamp(id){
	objDate = new Date();
	objDate.setYear(id.substr(0,4));
	objDate.setMonth(id.substr(6,2)-1);
	objDate.setDate(id.substr(4,2));
	objDate.setHours(id.substr(8,2));
	objDate.setMinutes(id.substr(10,2));
	return objDate.getTime();
}

// Translate words and phrases using user language from eGroupware.
function get_lang(_key,_arg1,_arg2,_arg3,_arg4) {
	if (!_key)
		return "";
	var key = _key.toLowerCase();
		if(array_lang[key])
			var _value = array_lang[key];
		else
			return _key+"*";

	if(_arg1 || _arg2 ||_arg3 || _arg4) {
		for(j = 1; j <= 4; j++){
			if(eval("_arg"+j)) {
				var regExp = new RegExp("%"+j+"");
				_value = _value.replace(regExp,eval("_arg"+j));
			}
		}
	}

	return _value;
}


function resizeEvent (eventDiv) {
	_dragArea.pressed = 1;
	_dragArea.initEvent = eventDiv.parentNode.id;
	_dragArea.resizing = 1;
	_dragArea.currentEvent = eventDiv;
}

refreshLang();
